<!doctype html>
<html>
<head>
<title>Event Room Notice</title>
<link rel="manifest" href="./manifest.json">
<style>
body {
  margin: 0;
  background-image: url('./images/hkoscon-2019-logo.png');
  background-position: calc(100% - 80px) bottom;
  background-repeat: no-repeat;
  min-height: 100vh;
}
#event-notice {
  margin: 0;
  padding: 0;
  width: 100vw;
  height: 100vh;
}

.event-header-wrapper {
  display: flex;
  align-items: center;
  justify-content: center;
  width: 80%;
  height: calc(100vh - 260px);
  margin: 0 auto;
}
.event-text-before-title {
  font-size: 3vw;
  box-sizing: border-box;
  text-align: center;
  color: rgba(0, 0, 0, 0.4);
}
.event-title {
  font-size: 4.6vw;
  box-sizing: border-box;
  text-align: center;
  color: rgba(0, 0, 0, 0.55);
}
.event-speakers {
  position: absolute;
  list-style-type: none;
  left: 0;
  bottom: 0;
  padding-left: 5em;
  text-align: left;
}
.event-speaker {
  display: inline-block;
  max-width: 16vw;
}
.event-speaker-card-thumbnail {
  width: 100%;
  border-radius: 50%;
  overflow: hidden;
}
.event-speaker-card-thumbnail img {
  display: block;
  width: 100%;
  height: auto;
}
.event-speaker-card figcaption {
  font-size: 1.5vw;
  padding: 0.5em 0;
  text-align: center;
}

.time-input-wrapper {
  width: 20em;
  height: calc(100% - 180px);
  margin: auto;
  display: flex;
  align-items: center;
  justify-content: center;
}
.time-input-wrapper .time-input-form {
  display: block;
  width: 100%;
  font-size: 2.5vh;
}
.time-input-wrapper .time-input-form label {
  display: block;
  width: 100%;
  text-align: center;
  margin-bottom: 0.5em;
  font-size: 1.2em;
}
.time-input-wrapper .time-input-form input {
  width: 100%;
  box-sizing: border-box;
  margin-bottom: 0.5em;
  font-size: inherit;
}
.time-input-wrapper .time-input-form .actions button {
  width: 100%;
  box-sizing: border-box;
  font-size: inherit;
}

.selection-wrapper {
  width: 40em;
  height: calc(100% - 180px);
  margin: auto;
  display: flex;
  align-items: center;
  justify-content: center;
}
.selection-wrapper .selection-form {
  display: block;
  width: 100%;
}
.selection-form .options {
  display: block;
  list-style-type: none;
  margin: 0;
  padding: 0;
}
.selection-form .options .option {
  display: block;
  margin: 2vh 0;
}
.selection-form .options .option button {
  font-size: 3vh;
  text-align: center;
  width: 100%;
  padding: 0.5em 0;
  display: block;
  border-radius: 0.5em;
  color: rgba(255, 255, 255, 0.8);
  background-color: rgba(0, 0, 0, 0.6);
  cursor: pointer;
  transition: all 0.2s;
}
.selection-form .options .option button:hover {
  color: rgba(255, 255, 255, 1);
  background-color: rgba(0, 0, 0, 0.3);
}
.selection-form .options .option button:focus {
  outline: none;
}

.notice-wrapper {
  display: flex;
  align-items: center;
  justify-content: center;
  width: 80%;
  height: calc(100vh - 260px);
  margin: 0 auto;
  text-align: center;
}
.notice-wrapper .notice .notice-title {
  font-size: 8vh;
  color: rgba(0, 0, 0, 0.6);
}
.notice-wrapper .notice .notice-message {
  font-size: 5vh;
  color: rgba(0, 0, 0, 0.8);
}

.timeline-wrapper {
  position: absolute;
  top: calc(99vh);
  left: 25%;
  width: 50%;
  top: calc(100vh - 300px);
}
.timeline {
  display: flex;
  width: 100%;
  background-color: #DDD;
  font-size: 3vh;
  border-radius: 0.5vh;
}
.timeline > div {
  height: 1vh;
}
.timeline .timeline-past {
  background-color: #666;
  position: relative;
  border-radius: 0.5vh 0.5vh;
}
.timeline .timeline-remaining {
  position: relative;
}
.timeline .timeline-start,
.timeline .timeline-end {
  position: absolute;
  top: calc(-1em - 2vh);
}
.timeline .timeline-end {
  right: 0;
}
.timeline .timeline-time {
  position: absolute;
  width: 1.2vh;
  height: 1.2vh;
  background-color: #FFF;
  border-radius: 50%;
  right: 0;
  bottom: 0;
  box-shadow: 1px 1px 5px 2px rgba(0, 0, 0, 0.3);
}
</style>
</head>
<body>
<main id="event-notice">
  <!-- placeholder -->
</main>
<script type="module">

import { format } from './js/String.prototype.js';
import { flattenTopics, reduceVenues, isTopic, byDate, byStartBefore, byEndAfter, byVenue } from './js/topics.js';
import { drawNoticeOn, drawNonEventNoticeOn, drawTimelineOn, drawOptionsSelOn, drawTimeSelOn } from './js/views.js';

// load service worker
if ('serviceWorker' in navigator) {
  window.addEventListener('load', () => {
    navigator.serviceWorker.register('./service-worker.js')
      .then((reg) => {
        // Registration was successful
        console.log('ServiceWorker registration successful with scope: ', reg.scope);
      })
      .catch((err) => {
        // registration failed :(
        console.log('ServiceWorker registration failed: ', err);
      });
  });
}

// Use extra String.prototype function "format".
Object.assign(String.prototype, {
  format,
});

const timeStrToMinutes = (timeStr) => {
  const [hour, minutes] = timeStr.split(':').map((str) => parseInt(str, 10));
  return hour * 60 + minutes;
}
// main
(async () => {
  const container = document.getElementById('event-notice');
  const drawOptionsSel = drawOptionsSelOn.bind(this, container);
  const drawNonEventNotice = drawNonEventNoticeOn.bind(this, container);
  const drawNotice = drawNoticeOn.bind(this, container);
  const drawTimeSel = drawTimeSelOn.bind(this, container);
  const drawTimeline = drawTimelineOn.bind(this, container, (startTime, endTime) => {
    let now = new Date(Date.now() + shiftTimeDiff * 1000);
    const startMinute = timeStrToMinutes(startTime);
    const endMinute = timeStrToMinutes(endTime);
    const nowMinute = now.getHours() * 60 + now.getMinutes();
    return (nowMinute - startMinute) / (endMinute - startMinute);
  });

  // Get the conference year list from server.
  const conferenceYearsRes = await fetch('https://events.cota.hk/api/v1/conferenceyear');
  const { conferenceYears } = await conferenceYearsRes.json();
  if (!conferenceYears) {
    drawNonEventNotice('Unable to read Conference Years list', '<p>Error fetching conference year list. Try again later.</p>');
    return;
  }

  // Prompt user to select a conference year.
  const conferenceYearName = await drawOptionsSel(
    conferenceYears
      .filter(({eventCount}) => (eventCount > 0))
      .map(({name}) => (name))
  );
  const conferenceYear = conferenceYears
    .filter(({name}) => (name === conferenceYearName))
    .shift();

  // Get the topics of the conference year.
  const daysRes = await fetch(conferenceYear.apis.days.href);
  const { days } = await daysRes.json();
  const allTopics = flattenTopics(days);

  const now = new Date();
  let nowDate = '%d-%02d-%02d'.format(now.getFullYear(), now.getMonth() + 1, now.getDay());
  const nowTime = '%02d:%02d'.format(now.getHours(), now.getMinutes());
  let shiftTimeDiff = 0; // number of timeshift by seconds.

  // make sure the today is a event date,
  // or show a selection option list for debug.
  const dates = days.map(({date}) => (date));
  if (dates.indexOf(nowDate) === -1) {
    nowDate = await drawOptionsSel(dates);
    const shiftedTime = await drawTimeSel({label: 'Simulate Time', buttonText: 'Select'});
    const [shiftedHours, shiftedMinutes] = shiftedTime.split(':').map((str) => parseInt(str, 10));
    shiftTimeDiff = (shiftedHours - now.getHours()) * 3600 + (shiftedMinutes - now.getMinutes()) * 60;
  }

  // provide a list of venue that has topic
  // on the day.
  const venue = await drawOptionsSel(
    reduceVenues(allTopics.filter(({date}) => (date === nowDate)))
  );

  class TopicNotFound {
    constructor() {
      this.message = 'Topic not found';
    }
  }

  const resolveTopic = (topics, nowTime, venue) => {
    // get topic to display, if any
    const currentTopic = topics
      .filter(isTopic())
      .filter(byDate(nowDate))
      .filter(byStartBefore(nowTime))
      .filter(byEndAfter(nowTime))
      .filter(byVenue(venue))
      .shift();
    if (typeof currentTopic !== 'undefined') {
      return Object.assign({current: true}, currentTopic);
    }

    // assumes the topics from "days" endpoint
    // are sorted properly by time.
    const nextTopic = topics
      .filter(isTopic())
      .filter(byDate(nowDate))
      .filter(({ startTime }) => (nowTime <= startTime))
      .filter(byEndAfter(nowTime))
      .filter(byVenue(venue))
      .shift();
    if (typeof nextTopic !== 'undefined') {
      return Object.assign({current: false}, nextTopic);
    }

    // Topic not found, raise error
    throw new TopicNotFound();
  }

  let lastTopic = { display: '', current: false };
  let updateNoticeIntervalID;

  const updateNotice = async () => {

    // re-capture the current time sting.
    const updateAt = new Date(Date.now() + shiftTimeDiff * 1000);
    const updateTime = '%02d:%02d'.format(updateAt.getHours(), updateAt.getMinutes());

    // for monitoring and debug.
    console.info(`updateNotice at ${'%02d:%02d:%02d'.format(
      updateAt.getHours(),
      updateAt.getMinutes(),
      updateAt.getSeconds()
    )}`);

    const res = await fetch(conferenceYear.apis.days.href);
    const { days } = await res.json();
    const allTopics = flattenTopics(days);

    try {
      const topic = resolveTopic(allTopics, updateTime, venue);

      if (lastTopic.display != topic.display
      || lastTopic.current != topic.current) {

        const {display, speakers, current, startTime, endTime} = topic;
        // draw the topic to notice board
        drawNotice(
          display,
          speakers,
          (current)
            ? `${venue}, Now`
            : `${venue}, Coming at ${startTime}`,
        );
        if (current) {
          drawTimeline(startTime, endTime);
        }

        // remember that this topic was last drawn
        lastTopic = topic;
      }
    } catch (e) {

      // find if there are any event left today
      const nextEventToday = allTopics
        .filter(byDate(nowDate))
        .filter(({ endTime }) => (updateTime <= endTime))
        .shift();

      // find if there is any event tomorrow
      const nextEventTomorrow = allTopics
        .filter(({ date }) => (date > nowDate))
        .shift();

      // clear the interval call
      clearInterval(updateNoticeIntervalID);
      console.log('clear interval updateNotice()');

      if (typeof nextEventToday !== 'undefined') {
        // show something if there are events elsewhere.
        drawNonEventNotice('Event Not Found', '<p>There is no more event in this room today.</p><p>You may want to try another room.</p>')
        return;
      }

      if (typeof nextEventTomorrow !== 'undefined') {
        // show something if there are events tomorrow.
        drawNonEventNotice('See you tomorrow!', '<p>All events are finished for today.</p><p>See you tomorrow.</p>')
        return;
      }

      // no more event this year.
      drawNonEventNotice('See you in 2020!', '<p>All events are finished for this year.</p><p>We hope you had a good time.</p><p>See you next year!</p>')
      return;
    }
  }

  // trigger the below closure with setInterval().
  updateNotice();
  updateNoticeIntervalID = setInterval(updateNotice, 15000); // every 15 seconds.

})();

</script>
</body>
</html>
